/*
 * Copyright (C) 2002-2005 StarBED Project All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
 * alist.c - association list
 * 
 * $Id: alist.c,v 1.1 2006/11/27 01:56:36 k-chinen Exp $
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "alist.h"

int
assoc(apair_t *al, char *xname)
{
    int i;
    apair_t *ret;

    ret = NULL;
    i = 0;
    while(al[i].name) {
        if(strcasecmp(al[i].name, xname)==0) {
            ret = &al[i];
        }
        i++;
    }

    if(ret)
        return ret->value;
    else
        return -1;
}


char*
xrassoc(apair_t *al, int xval)
{
    int i;
    apair_t *ret;

    ret = NULL;
    i = 0;
    while(al[i].name) {
        if(al[i].value == xval) {
            ret = &al[i];
        }
        i++;
    }

    if(ret)
        return ret->name;
    else
        return NULL;
}

static char *ignore_msg = "*ignore*";

char*
rassoc(apair_t *al, int xval)
{
    char *r;
    r = xrassoc(al, xval);
    if(r)
        return r;
    else
        return ignore_msg; 
}

void*
assoc_p(apair_t *al, int xval)
{
    int i;
    apair_t *ret;

    ret = NULL;
    i = 0;
    while(al[i].name) {
        if(al[i].value == xval) {
            ret = &al[i];
        }
        i++;
    }

    if(ret)
        return (void*)ret->name;
    else
        return NULL; 
}
