/*
 * Copyright (C) 2002-2005 StarBED Project All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
 * parse address and port
 */
int parse_ftp_peer(char *buf, char *addr_str, int *port)
{
    register char  *p, *q;
    int             c;
    int             hi, low;

    p = buf;

    while(*p && isdigit(*p)) {
        p++;
    }
    if(*p!=' '){
        goto fail;
    }
    p++;

/*
    Trace("message [%s]\n", p);
*/

    while(*p && *p!='(') {
        p++;
    }
    if(*p!='(') {
        goto fail;
    }
    p++;

/*
    Trace("specify addr and port [%s]\n", p);
*/

    memset(addr_str, 0, 256);
    q = addr_str;
    c = 0;
    while(*p && (isdigit(*p)||*p==',')) {
        if(*p==',') {
            c++;
            if(c==4)
                break;
            *q++ = '.';
            *p++;
        }
        else {
            *q++ = *p++;
        }
/*
        Trace("\taddr %-20s %s", addr_str, p);
*/
    }
    *q = '\0';
    if(*p!=',') {
        goto fail;
    }
    p++;
/*
    Trace("address [%s]\n", addr_str);
*/

    hi = 0;
    while(*p && isdigit(*p)) {
        hi = hi*10 + (*p - '0');
/*
        Trace("\tport hi  %4d %s", hi, p);
*/
        p++;
    }
    if(*p!=',') {
        goto fail;
    }
    p++;

    low = 0;
    while(*p && isdigit(*p)) {
        low = low*10 + (*p - '0');
/*
        Trace("\tport low %4d %s", low, p);
*/
        p++;
    }
    if(*p!=')') {
        goto fail;
    }
    p++;

    *port = hi * 256 + low;
/*
    Trace("port [%d] (%d,%d)\n", port, hi, low);
*/

    goto success;

fail:
    return -1;

success:
    return 0;
}

