/*
 * Copyright (C) 2002-2005 StarBED Project All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
 */

#ifndef _HTTP_H_
#define _HTTP_H_

#define HTTP_SERVPORTNO     (80)
#define HTTP_PROXYPORTNO    (3128)
#define HTTP_PORTNO         HTTP_SERVPORTNO

#define M_UNKNOW    0
#define M_HEAD      1
#define M_GET       2
#define M_POST      3
#define M_OPTION    4
#define M_PUT       5
#define M_DELETE    6
#define M_TRACE     7

int HTTP_find_header_term(char *line, int limit);
int HTTP_parse_version (char *vstr, int *ma, int *mi);

int HTTP_parse_simple_request(char *buf, int *rmethod, char *ur, char *ve);
int HTTP_parse_cachefields(char *buf ,int len ,int *xcachable ,int *xreload);
int HTTP_parse_request_header (char *buf, int *rmethod, char *ur, char *ve, int *xims, int *xcachable, int *xreload);

int HTTP_parse_response_header (char*, int,
        int*, int*, int*, time_t*, time_t*, off_t *, int*, int*);
int HTTP_parse_response_code(char *area, int len);

int HTTP_SendIgnoreMessage(int cfd ,int rcode ,char *short_msg ,char *long_msg);
int HTTP_send_image(int ofd, char *ctypestr, int len, char *img);

extern char *MSG_M_[];

#endif /* _HTTP_H_ */
