/*
 * Copyright (C) 2002-2005 StarBED Project All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
 *  KOTETU: signals (POSIX like) procedures
 *      by k-chinen@is.aist-nara.ac.jp, 1995
 *
 *  $Id: sigs.h,v 1.1 2006/11/27 01:56:36 k-chinen Exp $
 */


#ifndef KOTETU_SIGS_H
#define KOTETU_SIGS_H

#ifdef HAVE_SIGLONGJMP
#define SIGLONGJMP(x,y)     siglongjmp(x,y)
#else
#define SIGLONGJMP(x,y)     longjmp(x,y)
#endif

#ifdef HAVE_SIGSETJMP
#define SIGSETJMP(x,y)      sigsetjmp(x, y)
#else
#define SIGSETJMP(x,y)      setjmp(x)
#endif

#ifndef HAVE_SIG_ATOMIC_T
typedef int sig_atomic_t;
#endif

#ifndef HAVE_SIGJMP_BUF
typedef jmp_buf sigjmp_buf;
#endif

void SetSignalHandler(int signo, RETSIGTYPE (*handler)(int));

RETSIGTYPE PipeErrorHandler ();
RETSIGTYPE ReleseChild ();
RETSIGTYPE ExitProgram ();
RETSIGTYPE HookTERM();
RETSIGTYPE DoNothing ();

extern volatile sig_atomic_t pipe_broken;
extern volatile sig_atomic_t catch_termination;


#endif /* KOTETU_SIGS_H */

