/*
 * Copyright (C) 2002-2005 StarBED Project All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
 * $Id: sman.h,v 1.1 2006/11/27 01:56:36 k-chinen Exp $
 */
#ifndef _SMAN_H_
#define _SMAN_H_
/*
int fdprintf(const int fd, const char *fmt, ...);
*/
char *Chop_CRLF(char *line);
int Capitalize(char *line);
char *sgets(char *pos, char *buf, int blen);
void dump_string(char *prefix, char *line);
void dump_stringsegment(char *prefix, char *str, int len);
void dump_stringchunk(char *prefix, char *chunk);

int expand_hpat(char *dst, int dmax, char *pat);

int parse_cmd(char *line, int aplen, int amax, char *ap);


/*
 * misc macros
 */
#define strcmp_first_all(x, y0, y)      (x[0]==y0 && strcmp(x,y)==0)
#define Nstrcmp_first_all(x, y0, y)     (x[0]!=y0 || strcmp(x,y)!=0)
#define strcmp_first3(x, y0, y1, y2)    (x[0]==y0 && x[1]==y1 && x[2]==y2)
#define Nstrcmp_first3(x, y0, y1, y2)   (x[0]!=y0 || x[1]!=y1 || x[2]!=y2)
#define strncmp_first_all(x, n, y0, y)  (x[0]==y0 && strncmp(x,y,n)==0)
#define Nstrncmp_first_all(x, n, y0, y) (x[0]!=y0 || strncmp(x,y,n)!=0)
#define strcasecmp_first_all(x, y0, y) \
            ((x[0]==y0 || tolower(x[0])==tolower(y0)) && strcasecmp(x,y)==0)
#define Nstrcasecmp_first_all(x, y0, y) \
            ((x[0]!=y0 && tolower(x[0])!=tolower(y0)) || strcasecmp(x,y)!=0)
#define strncasecmp_first_all(x, n, y0, y) \
            ((x[0]==y0 || tolower(x[0])==tolower(y0)) && strncasecmp(x,y,n)==0)
#define Nstrncasecmp_first_all(x, n, y0, y) \
            ((x[0]!=y0 && tolower(x[0])!=tolower(y0)) || strncasecmp(x,y,n)!=0)


#endif /* _SMAN_H_ */

