/*
 * Copyright (C) 2002-2005 StarBED Project All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
 *
 * $Id: squeue.h,v 1.1 2006/11/27 01:56:36 k-chinen Exp $
 */

#ifndef _SQUEUE_H_
#define _SQUEUE_H_



typedef struct {
    pthread_mutex_t lock;
    pthread_cond_t  not_empty;
    pthread_cond_t  not_full;

    int cmax;
    int count;
    int sig;

    void **head;
    void **tail;
} sess_queue_t;



off_t sq_alloc_list(int);

int sq_init(sess_queue_t *self, int sz);
int sq_show(FILE *ofp, sess_queue_t *self);
int sq_show_mapfunc(FILE *, sess_queue_t *,
        void (func)(FILE*, void*, struct timeval*), struct timeval*);
int sq_showaddr_mapfunc(FILE *, sess_queue_t *,
        void (func)(FILE*, void*, struct timeval*), struct timeval*);


int     sq_raw_push(sess_queue_t *self, sess_t *xcell);
sess_t* sq_raw_pull(sess_queue_t *self);

int     sq_push(sess_queue_t *self, sess_t *xcell);
int     sq_timedpush(sess_queue_t *self, sess_t *xcell, int wait_time);

sess_t* sq_pull(sess_queue_t *self);
sess_t* sq_pull_nonblock(sess_queue_t *self);
sess_t* sq_timedpull(sess_queue_t *self, int wait_time);
int sq_pullchunk(sess_queue_t *self, sess_t *xchunk[], int range);

int     sq_pullback(sess_queue_t *self, sess_t *xcell);

sess_t* sq_get_free();
int sq_be_free(sess_t *);


#endif /* _SQUEUE_H_ */


